.\"	$NetBSD: dirname.3,v 1.13 2008/04/30 13:10:50 martin Exp $
.\"
.\" Copyright (c) 1997, 2002 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Klaus Klein and Jason R. Thorpe.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd May 10, 2008
.Dt DIRNAME 3
.Os
.Sh NAME
.Nm dirname
.Nd report the parent directory name of a file pathname
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In libgen.h
.Ft char *
.Fn dirname "char *path"
.Sh DESCRIPTION
The
.Fn dirname
function takes a pointer to a character string that contains a pathname,
.Ar path ,
and returns a pointer to a string that is a pathname of the parent directory of
.Ar path .
Trailing
.Sq /
characters in
.Ar path
are not counted as part of the path.
.Pp
If
.Ar path
does not contain a
.Sq / ,
then
.Fn dirname
returns a pointer to the string
.Dq \&. .
.Pp
If
.Ar path
is a null pointer or points to an empty string,
.Fn dirname
returns a pointer to the string
.Dq \&. .
.Sh RETURN VALUES
The
.Fn dirname
function returns a pointer to a string that is the parent directory of
.Ar path .
.Sh SEE ALSO
.Xr dirname 1 ,
.Xr basename 3
.Sh STANDARDS
.Bl -bullet -compact
.It
.St -xpg4.2
.It
.St -p1003.1-2001
.El
.Sh BUGS
If the length of the result is longer than
.Dv PATH_MAX
bytes
.Pq including the terminating nul ,
the result will be truncated.
.Pp
The
.Fn dirname
function returns a pointer to static storage that may be overwritten
by subsequent calls to
.Fn dirname .
This is not strictly a bug; it is explicitly allowed by
.St -p1003.1-2001 .
